﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WpfApplication1
{
    class Certificate
    {
        // ...
    }

    class Employee
    {
        public Employee(string name, DateTime birthday, string address)
        {
            lastId++;
            id = lastId;

            this.name = name;
            this.birthday = birthday;
            this.address = address;
        }

        int id;
        static int lastId;
        public static int GetLastId()
        {
            return lastId;
        }

        string name;
        DateTime birthday;
        string address;
        protected List<Certificate> certificates = new List<Certificate>();

        // ein klassischer Setter
        public void SetAddress(string address)
        {
            // ... hier Checks einbauen ...
            this.address = address;
        }

        // Property
        public string Address
        {
            set
            {
                // ... hier Checks einbauen ...
                address = value;
            }
        }

        public virtual void Work(double amount)
        {
            // ...
        }
    }

    class Manager : Employee
    {
        public Manager(string name, DateTime birthday, string address)
        : base(name, birthday, address)
        {
        }

        List<Share> shares = new List<Share>(); // Aktien

        public override void Work(double amount)
        {
            base.Work(0.5*amount);
            for (int i = 0; i < 1000; i++)
            {
                shares.Add(new Share());           
            }
        }
    }

    class Share
    {
        // ...
    }
}
